#!/usr/bin/env python

import sys, os

datasets = ['webspam', 'epsilon', 'leisure', 'heart_scale']
datasets = ['webspam','epsilon']
trainsize = {'webspam': 280000, 'epsilon': 400000, \
		'leisure':368443, 'heart_scale':216}
datadir = './'

os.system('cd ./utils; make')

def subset(data):
	src = os.path.join(datadir, data)
	train = src + '.train'
	test = src + '.test'
	if os.path.exists(train) and os.path.exists(test):
		print('\tExists.')
	else:
		cmd = './utils/subset.py %s %s %s %s' %\
				(src, trainsize[data], train, test)
		print cmd
		os.system(cmd)

for data in datasets:
	print('Generate train/test for %s...' % (data))
	# Check data existence
	if data == 'epsilon':
		if os.path.exists('epsilon.scale.train') and  os.path.exists('epsilon.scale.test'):
			print('\tExist')
			continue
	elif data == 'webspam':
		if os.path.exists('webspam.train') and os.path.exists('webspam.test'):
			print('\tExist')
			continue

	# Fetch data from web
	if data == 'webspam':
		datapath = os.path.join(datadir, 'webspam')
		bz2path = os.path.join(datadir, 'webspam.bz2')
		print('Get webspam from web...')
		if os.path.exists(datapath):
			print('\tExist')
		else:
			if not os.path.exists(bz2path):
				cmd = 'wget -O %s http://www.csie.ntu.edu.tw/~cjlin/libsvmtools/datasets/binary/webspam_wc_normalized_trigram.svm.bz2' % (bz2path)
				print cmd
				os.system(cmd)
			cmd = 'bunzip2 %s' % (bz2path)
			print cmd
			os.system(cmd)
	elif data == 'epsilon':
		os.system('./fetchepsilon.py')
	elif data == 'leisure':
		print('leisure is not available online')
	elif data == 'heart_scale':
		cmd = 'wget -O heart_scale http://www.csie.ntu.edu.tw/~cjlin/libsvmtools\
				datasets/binary/heart_scale' 
		print cmd
		os.system(cmd)

	subset(data)

	if data == 'epsilon':
		print('Scale epsilon.train epsilon.test ...')
		os.system('./utils/scale epsilon.train')
		os.system('./utils/scale epsilon.train epsilon.train epsilon.scale.train')
		os.system('./utils/scale epsilon.train epsilon.test epsilon.scale.test')
	elif data == 'webspam':
		datapath = os.path.join(datadir,'webspam.train')
		rawdatapath = os.path.join(datadir,'webspam.train.raw')
		print('Generate %s' % rawdatapath)	
		if os.path.exists(rawdatapath):
			print('\tExist')
		else :
			cmd = "grep '^+1' %s > %s; grep '^-1' %s >> %s" %\
					(datapath, rawdatapath, datapath, rawdatapath)
			print cmd
			os.system(cmd)
