#!/usr/bin/env python

import sys, math, os
import bz2

datadir = './'
lab_url = 'ftp://ftp.first.fraunhofer.de/pub/projects/largescale/epsilon/epsilon_train.lab.bz2'
dat_url = 'ftp://ftp.first.fraunhofer.de/pub/projects/largescale/epsilon/epsilon_train.dat.bz2'
lab = os.path.join(datadir, 'epsilon.lab.bz2')
dat = os.path.join(datadir, 'epsilon.dat.bz2')
out = os.path.join(datadir, 'epsilon')

print('Get epsilon from web...')
if os.path.exists(out):
	print('\tExist.')
	exit(0)
if not os.path.exists(lab):
	cmd = 'wget -O %s %s' % (lab, lab_url)
	print cmd
	os.system(cmd)
if not os.path.exists(dat):
	cmd = 'wget -O %s %s' % (dat, dat_url)
	print cmd
	os.system(cmd)

lab = bz2.BZ2File(lab)
dat = bz2.BZ2File(dat)
out = open(out,'w')

for line in lab:
	y = line.strip()
	x = dat.readline().strip()
	x = list(map(float, x.split()))
	length = math.sqrt(sum([v*v for v in x]))
	x = ' '.join(['%s:%g' %(i+1, v/length) for i,v in enumerate(x)])
	out.write('%s %s\n' % (y, x))
	
out.close()

